/**
 * Style for ApImage.
 * @constructor ApImageStyle
 */

"use strict";

const React = require('react'),
    types = React.PropTypes,
    extend = require('extend'),
    ApStyle = require('apeman-react-style')['ApStyle'];

/** @lends ApImageStyle */
let ApImageStyle = React.createClass({
    propTypes: {
        scoped: types.bool,
        style: types.object,
        backgroundColor: types.string
    },
    getDefaultProps: function () {
        return {
            scoped: false,
            style: {},
            backgroundColor: '#DDD',
            spinColor: 'rgba(255,255,255,0.5)'
        }
    },
    render: function () {
        let s = this,
            props = s.props;

        let backgroundColor = props.backgroundColor,
            spinColor = props.spinColor;

        let data = {
                '.ap-image': {
                    backgroundColor: `${backgroundColor}`,
                    overflow: `hidden`,
                    textAlign: `center`,
                    display: `inline-block`,
                    position: `relative`
                },
                '.ap-image-content': {
                    position: `absolute`,
                    display: `inline-block`
                },
                '.ap-image-spinner': {
                    position: `absolute`,
                    left: 0,
                    top: 0,
                    right: 0,
                    bottom: 0,
                    textAlign: `center`,
                    display: `block`,
                    zIndex: 8,
                    backgroundColor: `rgba(0,0,0,0.1)`,
                    color: `${spinColor}`
                },
                '.ap-image-notfound': {
                    display: `block`,
                    textAlign: `center`,
                    color: `rgba(0,0,0,0.1)`,
                    fontFamily: `monospace`
                }
            },
            smallMediaData = {},
            mediumMediaData = {},
            largeMediaData = {};
        return (
            <ApStyle scoped={props.scoped}
                     data={extend(data, props.style)}
                     smallMediaData={smallMediaData}
                     mediumMediaData={mediumMediaData}
                     largeMediaData={largeMediaData}
            >{props.children}</ApStyle>
        );
    }
});

module.exports = ApImageStyle;
